#include <sstream>
#include "node.hpp"

class Parser : public istringstream {
	private:
		enum {
			PLUS, MINUS, ASTER, DIV, MOD, PLUSPLUS, PLUSEQ, 
			EQ, EQEQ, MINUSMINUS, MINUSEQ,
			BAD
		};

		void gettok(void);
		Node *expr(void);
		Node *term(void);
		Node *factor(void);
		Node *prim(void);
		int  ch;		// ultimo caracter leido
		int  tok;		// ultimo token leido
		double num; 	// ultimo numero leido
	public:
		Parser(string);
		Node *GetExpr(void);
};

Parser::Parser(string str) : istringstream(str)
{
}

int Parser::gettok(void)
{
	int  ch;
	*this >> ws;			// ws = white space 
	ch= this->get();
	switch(ch) {
		case '+': 	if (this->peek()=='+') {
						this->get();
						tok= PLUSPLUS;
					}	
					else
					if (this->peek()=='=') {
						this->get();
						tok= PLUSEQ;
					}	
					else
						tok= PLUS;
					break;

		case '-': 	if (this->peek()=='-') {
						this->get();
						tok= MINUSMINUS;
					}	
					else
					if (this->peek()=='=') {
						this->get();
						tok= MINUSEQ;
					}	
					else
						tok= MINUS;
					break;
		case '*':	tok= ASTER;
					break;
		case '/':	tok= DIV;
					break;
		case '%':	tok= MOD;
					break;
		case '=':	if (this->peek()=='=') {
						this->get();
						tok= EQEQ;
					}
					else
						tok= EQ;
					break;
		default:	tok= BAD;
					break;
	}
	return tok;
}

